/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the GeneratedCaptcha type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GeneratedCaptcha{}

// GeneratedCaptcha struct for GeneratedCaptcha
type GeneratedCaptcha struct {
	Id  *string        `json:"id,omitempty"`
	Img NullableString `json:"img,omitempty"`
}

// NewGeneratedCaptcha instantiates a new GeneratedCaptcha object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGeneratedCaptcha() *GeneratedCaptcha {
	this := GeneratedCaptcha{}
	return &this
}

// NewGeneratedCaptchaWithDefaults instantiates a new GeneratedCaptcha object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGeneratedCaptchaWithDefaults() *GeneratedCaptcha {
	this := GeneratedCaptcha{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *GeneratedCaptcha) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GeneratedCaptcha) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *GeneratedCaptcha) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *GeneratedCaptcha) SetId(v string) {
	o.Id = &v
}

// GetImg returns the Img field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GeneratedCaptcha) GetImg() string {
	if o == nil || IsNil(o.Img.Get()) {
		var ret string
		return ret
	}
	return *o.Img.Get()
}

// GetImgOk returns a tuple with the Img field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GeneratedCaptcha) GetImgOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Img.Get(), o.Img.IsSet()
}

// HasImg returns a boolean if a field has been set.
func (o *GeneratedCaptcha) HasImg() bool {
	if o != nil && o.Img.IsSet() {
		return true
	}

	return false
}

// SetImg gets a reference to the given NullableString and assigns it to the Img field.
func (o *GeneratedCaptcha) SetImg(v string) {
	o.Img.Set(&v)
}

// SetImgNil sets the value for Img to be an explicit nil
func (o *GeneratedCaptcha) SetImgNil() {
	o.Img.Set(nil)
}

// UnsetImg ensures that no value is present for Img, not even an explicit nil
func (o *GeneratedCaptcha) UnsetImg() {
	o.Img.Unset()
}

func (o GeneratedCaptcha) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GeneratedCaptcha) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if o.Img.IsSet() {
		toSerialize["img"] = o.Img.Get()
	}
	return toSerialize, nil
}

type NullableGeneratedCaptcha struct {
	value *GeneratedCaptcha
	isSet bool
}

func (v NullableGeneratedCaptcha) Get() *GeneratedCaptcha {
	return v.value
}

func (v *NullableGeneratedCaptcha) Set(val *GeneratedCaptcha) {
	v.value = val
	v.isSet = true
}

func (v NullableGeneratedCaptcha) IsSet() bool {
	return v.isSet
}

func (v *NullableGeneratedCaptcha) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGeneratedCaptcha(val *GeneratedCaptcha) *NullableGeneratedCaptcha {
	return &NullableGeneratedCaptcha{value: val, isSet: true}
}

func (v NullableGeneratedCaptcha) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGeneratedCaptcha) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
